-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>6 then
lib.classes["SHAMAN"] = {}
lib.classpreload["SHAMAN"] = function()
	lib.AddSpell("Astral Shift",{108271},true)
end
lib.classes["SHAMAN"][2] = function()
--	lib.SetDOT("fs",nil,"fn",2)
	cfg.talents={
	["Boulderfist"]=IsPlayerSpell(201897),
	["Hailstorm"]=IsPlayerSpell(210853),
	["Overcharge"]=IsPlayerSpell(210727),
	["Hot Hand"]=IsPlayerSpell(201900),
	["Windsong"]=IsPlayerSpell(201898),
	["Sundering"]=IsPlayerSpell(197214),
	["Crashing Storm"]=IsPlayerSpell(192246),
	["Earthen Spike"]=IsPlayerSpell(188089),
	["Fury of Air"]=IsPlayerSpell(197211),
	["Tempest"]=IsPlayerSpell(192234),
	}
	lib.SetPower("MAELSTROM")
	--[[if cfg.talents["Boulderfist"] then
		cfg.cap=cfg.Power.max - 25
	else
		cfg.cap=cfg.Power.max - 15
	end]]
	lib.AddSpell("Lava Lash",{60103})
	if cfg.talents["Tempest"] then
		cfg.cap=40*2
	else
		cfg.cap=40*1.5
	end
	
	lib.AddResourceBar(cfg.Power.max,cfg.cap+lib.GetSpellCost("Lava Lash"))
	lib.ChangeResourceBarType(cfg.Power.type)
	if cfg.talents["Boulderfist"] then
		lib.AddSpell("Rockbiter",{201897})
	else
		lib.AddSpell("Rockbiter",{193786})
	end
	--lib.AddSpell("RB",{193786}
	lib.AddSpell("Stormstrike",{17364})
	lib.AddSpell("Flametongue",{193796})
	lib.AddAura("Flametongue",194084,"buff","player")
	lib.AddAura("Hot Hand",215785,"buff","player")
	lib.AddSpell("Lightning Shield",{192106},true)
	lib.AddSpell("Fury of Air",{197211},true)
	lib.AddAura("Stormbringer",201846,"buff","player")
	lib.SetTrackAura("Stormbringer")
	lib.SetAuraFunction("Stormbringer","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["player"],lib.GetAuraStacks("Stormbringer")>0 and lib.GetAuraStacks("Stormbringer") or nil)
	end)
	lib.AddSpell("Ascendance",{114051},true) -- Ascendance
	lib.SetAuraFunction("Ascendance","OnApply",function()
		cfg.spells["Stormstrike"].realid=115356
		lib.SetSpellIcon("Stormstrike")
	end)
	lib.SetAuraFunction("Ascendance","OnFade",function()
		cfg.spells["Stormstrike"].realid=17364
		lib.SetSpellIcon("Stormstrike")
	end)
	lib.AddSpell("Windsong",{201898},true)
	lib.AddSpell("Frostbrand",{196834},true)
	lib.AddSpell("Lightning Bolt",{187837})
	lib.AddSpell("Feral Spirit",{51533})
	lib.AddSpell("Feral Lunge",{196884})
	lib.AddSpell("Sundering",{197214})
	lib.AddSpell("Earthen Spike",{188089})
	lib.AddSpell("Crash Lightning",{187874}) --,true
	lib.AddAura("Crash Lightning",187878,"buff","player")
	--lib.SetDOT("Crash Lightning",10,nil,2) --,nil,nil,true
	lib.AddSpell("Doom Winds",{204945},true)
	lib.AddSpell("Healing Surge",{188070})
	lib.AddAura("Stormlash",195222,"buff","player","any")
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Shear")
	table.insert(cfg.plistdps,"Cleanse")
	table.insert(cfg.plistdps,"Purge")
	table.insert(cfg.plistdps,"Astral Shift")
	table.insert(cfg.plistdps,"Healing Surge")
	table.insert(cfg.plistdps,"Lightning Shield")
	table.insert(cfg.plistdps,"Feral Lunge_range")
	if not cfg.talents["Overcharge"] then
		table.insert(cfg.plistdps,"Lightning Bolt_range")
	end
	table.insert(cfg.plistdps,"Feral Spirit")
	if cfg.talents["Boulderfist"] then
		table.insert(cfg.plistdps,"Boulderfist_max")
	end
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistdps,"Frostbrand_noFrostbrand")
	end
	table.insert(cfg.plistdps,"Flametongue_noFlametongue")
	if cfg.talents["Windsong"] then
		table.insert(cfg.plistdps,"Windsong")
	end
	table.insert(cfg.plistdps,"Ascendance")
	if cfg.talents["Fury of Air"] then
		table.insert(cfg.plistdps,"Fury of Air")
	end
	table.insert(cfg.plistdps,"Doom Winds")
	table.insert(cfg.plistdps,"Crash Lightning_cleave3")
--	table.insert(cfg.plistdps,"Crash Lightning_cleave2")
	table.insert(cfg.plistdps,"Stormstrike")
	--table.insert(cfg.plistdps,"Stormbringer")
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistdps,"Frostbrand_noFrostbrand_re")
	end
	table.insert(cfg.plistdps,"Flametongue_noFlametongue_re")
	if cfg.talents["Overcharge"] then
		table.insert(cfg.plistdps,"Lightning Bolt_cap")
	end
	if cfg.talents["Hot Hand"] then
		table.insert(cfg.plistdps,"Hot Hand")
	end
	if cfg.talents["Earthen Spike"] then
		table.insert(cfg.plistdps,"Earthen Spike")
	end
	table.insert(cfg.plistdps,"Crash Lightning_cleave2")
	if cfg.talents["Crashing Storm"] then
		table.insert(cfg.plistdps,"Crash Lightning")
	end
	if cfg.talents["Sundering"] then
		table.insert(cfg.plistdps,"Sundering")
	end
	table.insert(cfg.plistdps,"Lava Lash_cap")
	if not cfg.talents["Boulderfist"] then
		table.insert(cfg.plistdps,"Rockbiter")
	end
	table.insert(cfg.plistdps,"Flametongue")
	if cfg.talents["Boulderfist"] then
		table.insert(cfg.plistdps,"Rockbiter")
	end
	table.insert(cfg.plistdps,"end")
--[[	table.insert(cfg.plistdps,"Shear")
	table.insert(cfg.plistdps,"Cleanse")
	table.insert(cfg.plistdps,"Purge")
	table.insert(cfg.plistdps,"Astral Shift")
	table.insert(cfg.plistdps,"Healing Surge")
	table.insert(cfg.plistdps,"Lightning Shield")
	table.insert(cfg.plistdps,"Feral Lunge_range")
	if not cfg.talents["Overcharge"] then
		table.insert(cfg.plistdps,"Lightning Bolt_range")
	end
	table.insert(cfg.plistdps,"Ascendance")
	table.insert(cfg.plistdps,"Doom Winds")
	if cfg.talents["Windsong"] then
		table.insert(cfg.plistdps,"Windsong")
	end
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistdps,"Frostbrand_noFrostbrand")
	end
	if cfg.talents["Boulderfist"] then
		table.insert(cfg.plistdps,"Boulderfist_max")
	end
	table.insert(cfg.plistdps,"Crash Lightning_cleave2")
	table.insert(cfg.plistdps,"Feral Spirit")
	table.insert(cfg.plistdps,"Stormbringer")
	if cfg.talents["Hot Hand"] then
		table.insert(cfg.plistdps,"Hot Hand")
	end
	if cfg.talents["Earthen Spike"] then
		table.insert(cfg.plistdps,"Earthen Spike")
	end
	table.insert(cfg.plistdps,"Flametongue_noFlametongue")
	table.insert(cfg.plistdps,"Stormstrike")
	if cfg.talents["Sundering"] then
		table.insert(cfg.plistdps,"Sundering")
	end
	if cfg.talents["Fury of Air"] then
		table.insert(cfg.plistdps,"Fury of Air")
	end
	table.insert(cfg.plistdps,"Crash Lightning_cleave2_re")
	if cfg.talents["Overcharge"] then
		table.insert(cfg.plistdps,"Lightning Bolt_cap")
	end
	if cfg.talents["Crashing Storm"] then
		table.insert(cfg.plistdps,"Crash Lightning_cap")
	end
	table.insert(cfg.plistdps,"Lava Lash_cap")
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistdps,"Frostbrand_noFrostbrand_re")
	end
	table.insert(cfg.plistdps,"Flametongue_noFlametongue_re")
	table.insert(cfg.plistdps,"Rockbiter")
	table.insert(cfg.plistdps,"Flametongue")
	table.insert(cfg.plistdps,"end")]]

	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Shear")
	table.insert(cfg.plistaoe,"Cleanse")
	table.insert(cfg.plistaoe,"Purge")
	table.insert(cfg.plistaoe,"Astral Shift")
	table.insert(cfg.plistaoe,"Healing Surge")
	table.insert(cfg.plistaoe,"Lightning Shield")
	table.insert(cfg.plistaoe,"Feral Lunge_range")
	table.insert(cfg.plistaoe,"Feral Spirit")
	table.insert(cfg.plistaoe,"Crash Lightning")
	table.insert(cfg.plistaoe,"Stormbringer_aoe")
	if cfg.talents["Hot Hand"] then
		table.insert(cfg.plistaoe,"Hot Hand_aoe")
	end
	if cfg.talents["Fury of Air"] then
		table.insert(cfg.plistaoe,"Fury of Air")
	end
	table.insert(cfg.plistaoe,"Stormstrike_aoe")
	table.insert(cfg.plistaoe,"Lava Lash_aoe")
	if cfg.talents["Hailstorm"] then
		table.insert(cfg.plistaoe,"Frostbrand_noFrostbrand")
	end
	table.insert(cfg.plistaoe,"Flametongue_noFlametongue")
	table.insert(cfg.plistaoe,"Rockbiter")
	table.insert(cfg.plistaoe,"end")
		
	cfg.plist=cfg.plistdps

	cfg.case = {
		["Boulderfist_max"] = function ()
			if cfg.Power.now>=cfg.Power.max-25 then return nil end
			return lib.SimpleCDCheck("Rockbiter",lib.GetSpellCD("Rockbiter",nil,lib.GetSpellMaxCharges("Rockbiter")))
			
--			if lib.GetSpellCharges("Rockbiter")>1 then return lib.SimpleCDCheck("Rockbiter") end
--			return nil
		end,
		["Stormbringer"] = function()
			if lib.GetAura({"Stormbringer"})>lib.GetSpellCD("Stormstrike") then
				return lib.SimpleCDCheck("Stormstrike")
			end
			return nil
		end,
		["Hot Hand"] = function()
			if lib.GetAura({"Hot Hand"})>lib.GetSpellCD("Lava Lash") then
				return lib.SimpleCDCheck("Lava Lash")
			end
			return nil
		end,
		["Stormbringer_aoe"] = function()
			if lib.GetAura({"Crash Lightning"})>lib.GetSpellCD("Stormstrike") and lib.GetAura({"Stormbringer"})>lib.GetSpellCD("Stormstrike") then
				return lib.SimpleCDCheck("Stormstrike")
			end
			return nil
		end,
		["Stormstrike_aoe"] = function()
			if lib.GetAura({"Crash Lightning"})>lib.GetSpellCD("Stormstrike") then
				return lib.SimpleCDCheck("Stormstrike")
			end
			return nil
		end,
		["Hot Hand_aoe"] = function()
			if lib.GetAura({"Crash Lightning"})>lib.GetSpellCD("Lava Lash") and lib.GetAura({"Hot Hand"})>lib.GetSpellCD("Lava Lash") then
				return lib.SimpleCDCheck("Lava Lash")
			end
			return nil
		end,
		["Lava Lash_aoe"] = function()
			if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			if lib.GetAura({"Crash Lightning"})>lib.GetSpellCD("Lava Lash") then
				return lib.SimpleCDCheck("Lava Lash")
			end
			return nil
		end,
		["Lightning Bolt_range"] = function()
			if lib.inrange("Flametongue") then return nil end
			return lib.SimpleCDCheck("Lightning Bolt")
		end,
		["Feral Lunge_range"] = function()
			if lib.inrange("Feral Lunge") then
				return lib.SimpleCDCheck("Feral Lunge")
			end
			return nil
		end,
		["Feral Spirit"] = function()
			if cfg.Power.now>=cfg.cap+lib.GetSpellCost("Lava Lash") then return nil end
			if not cfg.onGround then return nil end
			return lib.SimpleCDCheck("Feral Spirit")
		end,
		["Fury of Air"] = function()
			if cfg.Power.now>=cfg.cap then
				return lib.SimpleCDCheck("Fury of Air",lib.GetAura({"Fury of Air"}))
			end
			return nil
		end,
		["Lightning Bolt_cap"] = function()
			if cfg.Power.now>=cfg.cap then
				return lib.SimpleCDCheck("Lightning Bolt")
			end
			return nil
		end,
		["Doom Winds"] = function()
			if cfg.Power.now>=cfg.cap+lib.GetSpellCost("Lava Lash") then return nil end
			if not lib.inrange("Lava Lash") then return nil end
			if lib.GetAura({"Flametongue"})>lib.GetSpellCD("Doom Winds") and (not cfg.talents["Hailstorm"] or (cfg.talents["Hailstorm"] and lib.GetAura({"Frostbrand"})>lib.GetSpellCD("Doom Winds"))) then --lib.GetAura({"Stormlash"})>lib.GetSpellCD("Doom Winds") and 
				return lib.SimpleCDCheck("Doom Winds")
			end
			return nil
		end,
		["Windsong"] = function()
			if not lib.inrange("Lava Lash") then return nil end
			if lib.GetAura({"Flametongue"})>lib.GetSpellCD("Windsong") and (not cfg.talents["Hailstorm"] or (cfg.talents["Hailstorm"] and lib.GetAura({"Frostbrand"})>lib.GetSpellCD("Windsong"))) then --lib.GetAura({"Stormlash"})>lib.GetSpellCD("Windsong") and 
				return lib.SimpleCDCheck("Windsong")
			end
			if lib.GetAura({"Doom Winds"})>lib.GetSpellCD("Windsong") then
				return lib.SimpleCDCheck("Windsong")
			end
			return nil
		end,
		["Ascendance"] = function()
			if cfg.Power.now>=lib.GetSpellCost("Stormstrike") and (lib.GetAura({"Stormbringer"})>lib.GetSpellCD("Ascendance") or lib.GetSpellCD("Ascendance")<lib.GetSpellCD("Stormstrike")) then
				return lib.SimpleCDCheck("Ascendance")
			end
			return nil
		end,
		["Lightning Shield"] = function()
			return lib.SimpleCDCheck("Lightning Shield",(lib.GetAura({"Lightning Shield"})))
		end,
		["Flametongue_noFlametongue_re"] = function()
			return lib.SimpleCDCheck("Flametongue",(lib.GetAura({"Flametongue"})-4.8))
		end,
		["Frostbrand_noFrostbrand_re"] = function()
			--if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			return lib.SimpleCDCheck("Frostbrand",(lib.GetAura({"Frostbrand"})-4.5))
		end,
		["Crash Lightning_re"] = function()
			--if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			return lib.SimpleCDCheck("Crash Lightning",(lib.GetAura({"Crash Lightning"})-3))
		end,
		["Crash Lightning_cleave2"] = function()
			--if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			if cfg.cleave_targets>=2 then --and lib.GetAura({"Flametongue"})>lib.GetSpellCD("Crash Lightning") and (not cfg.talents["Hailstorm"] or (cfg.talents["Hailstorm"] and lib.GetAura({"Frostbrand"})>lib.GetSpellCD("Crash Lightning"))) then
				return lib.SimpleCDCheck("Crash Lightning") --,(lib.GetAura({"Crash Lightning"})))
			end
			return nil
		end,
		["Crash Lightning_cleave3"] = function()
			--if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			if cfg.cleave_targets>=3 then --and lib.GetAura({"Flametongue"})>lib.GetSpellCD("Crash Lightning") and (not cfg.talents["Hailstorm"] or (cfg.talents["Hailstorm"] and lib.GetAura({"Frostbrand"})>lib.GetSpellCD("Crash Lightning"))) then
				return lib.SimpleCDCheck("Crash Lightning")
			end
			return nil
		end,
		["Crash Lightning_cleave2_re"] = function()
			if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			if cfg.cleave_targets>1  then --and lib.GetAura({"Flametongue"})>lib.GetSpellCD("Crash Lightning") and (not cfg.talents["Hailstorm"] or (cfg.talents["Hailstorm"] and lib.GetAura({"Frostbrand"})>lib.GetSpellCD("Crash Lightning"))) then
				return lib.SimpleCDCheck("Crash Lightning")
			end
			return nil
		end,
		["Crash Lightning_aoe"] = function()
			--if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			if lib.GetAura({"Flametongue"})>lib.GetSpellCD("Crash Lightning") and (not cfg.talents["Hailstorm"] or (cfg.talents["Hailstorm"] and lib.GetAura({"Frostbrand"})>lib.GetSpellCD("Crash Lightning"))) then
				return lib.SimpleCDCheck("Crash Lightning") --,(lib.GetAura({"Crash Lightning"}))
			end
			return nil
		end,
		["Flametongue_noFlametongue"] = function()
			return lib.SimpleCDCheck("Flametongue",(lib.GetAura({"Flametongue"})))
		end,
		["Frostbrand_noFrostbrand"] = function()
			--if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			return lib.SimpleCDCheck("Frostbrand",(lib.GetAura({"Frostbrand"})))
		end,
		["Crash Lightning_noCrash Lightning"] = function()
			if cfg.Power.now<lib.GetSpellCost("Stormstrike") then return nil end
			return lib.SimpleCDCheck("Crash Lightning",(lib.GetAura({"Crash Lightning"})))
		end,
		
		["Lava Lash_cap"] = function()
			if cfg.Power.now>=90 then --cfg.cap+lib.GetSpellCost("Lava Lash") 
				return lib.SimpleCDCheck("Lava Lash")
			end
			return nil
		end,
		["Crash Lightning_cap"] = function()
			if cfg.Power.now>=80 then --cfg.cap+lib.GetSpellCost("Crash Lightning")
				return lib.SimpleCDCheck("Crash Lightning")
			end
			return nil
		end
	}

	lib.AddRangeCheck({
	{"Lava Lash",nil},
	{"Flametongue",{0,1,0,1}},
	{"Feral Lunge",{1,1,0,1}},
	{"Lightning Bolt",{0,0,1,1}},
	})
	
--[[	function Heddclassevents.COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventtype,_,sourceGUID,sourceName,_,_,destGUID,destName,_,_,spellId,spellName,_,_,interrupt)
		if sourceGUID == cfg.GUID["player"] and spellId and spellId==lib.GetSpellId("Crash Lightning") then
			if eventtype == "SPELL_DAMAGE" then
				if HeddDB.cleave.hit_time == timeStamp then
					HeddDB.cleave.num = HeddDB.cleave.num + 1
				else
					HeddDB.cleave.hit_time = timeStamp
					HeddDB.cleave.num = 1
					HeddDB.cleave.targets={}
				end
				HeddDB.cleave.targets[destGUID]=true
				if HeddDB.cleave.num>1 then
					lib.CDtoggleOn("Crash Lightning")
				else
					lib.CDtoggleOff("Crash Lightning")
				end
				cfg.Update=true
			elseif eventtype == "SPELL_CAST_SUCCESS" and spellId==lib.GetSpellId("Crash Lightning") then
				HeddDB.cleave.cast_time = timeStamp
				if HeddDB.cleave.cast_time>HeddDB.cleave.hit_time then
					HeddDB.cleave.targets={}
					HeddDB.cleave.num=0
					lib.CDtoggleOff("Crash Lightning")
				end
				cfg.Update=true
			end
			
			if eventtype == "UNIT_DIED" or eventtype == "UNIT_DESTROYED"  then
				if cfg.DOT.targets[destGUID] then
					HeddDB.cleave.num=HeddDB.cleave.num-1
					HeddDB.cleave.targets[destGUID]=nil
					if HeddDB.cleave.num>1 then
						lib.CDtoggleOn("Crash Lightning")
					else
						lib.CDtoggleOff("Crash Lightning")
					end
					cfg.Update=true
					return
				end
			end
		end
	end]]
	lib.myonupdate = function()
		lib.GroundUpdate()
	end

	cfg.spells_single={"Lightning Bolt"}	
	return true
end

lib.classpostload["SHAMAN"] = function()
	cfg.set["T17"]={115575,115576,115577,115578,115579}
	cfg.set["T18"]={124293,124297,124302,124303,124308}
	cfg.trinket["Class"]={124521}
	lib.UpdateSet()
	
	lib.AddDispellPlayer("Cleanse",{51886},{"Curse"}) -- Cleanse Spirit
	lib.AddDispellTarget("Purge",{370},{"Magic"}) 
	lib.SetInterrupt("Shear",{57994})
	
	cfg.case["Astral Shift"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 then
			return lib.SimpleCDCheck("Astral Shift")
		end
		return nil
	end
	
	cfg.case["Healing Surge"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 and cfg.Power.now>=20 then
			return lib.SimpleCDCheck("Healing Surge")
		end
		return nil
	end

	lib.UpdateTotem(1)

	function Heddclassevents.PLAYER_ENTERING_WORLD()
		lib.UpdateTotem(1)
	end
	
	function Heddclassevents.PLAYER_TOTEM_UPDATE(...)
		lib.UpdateTotem(1)
	end
	
	lib.CD = function()
		lib.CDadd("Shear")
		lib.CDadd("Purge")
		lib.CDadd("Cleanse")
		lib.CDadd("Astral Shift")
		lib.CDadd("Healing Surge")
		lib.CDAddCleave("Crash Lightning")
		lib.CDadd("Ascendance")
		lib.CDadd("Windsong")
		lib.CDadd("Doom Winds")
		lib.CDadd("Lightning Shield")
		lib.CDadd("Lightning Bolt")
		lib.CDadd("Fury of Air")
		lib.CDadd("Sundering")
		lib.CDadd("Earthen Spike")
		lib.CDadd("Feral Spirit")
		lib.CDaddTimers("Feral Spirit","Feral Spirit",function(self, event, unitID,spellname, rank, castid, spellID)
			if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("Feral Spirit") then
				CooldownFrame_SetTimer(self.cooldown,GetTime(),15,1)
			end
		end
		,{"UNIT_SPELLCAST_SUCCEEDED"})
		
		lib.CDadd("Feral Lunge")
		lib.CDadd("Heroism")
		lib.CDaddTimers("Heroism","Exhaustion","auras",nil,true,{0, 1, 0})
		lib.CDturnoff("Heroism")
	end
end
end